= Code Analysis =
[[TOC(heading=About SecureCI™,depth=2,AboutSecureCI/*)]]

Code analysis tools run against compiled or raw source files to look for patterns that indicate potential problems. 
They look for style issues, potential code defects, and even race conditions and security holes. These tools are more 
akin to automated code review than to unit and integration tests, and are an inexpensive way to avoid the tedium of 
repeatedly reviewing a large code base.

Most modern IDEs do some code analysis on-the-fly. These inspections tend to be stylistic and syntax oriented, and 
give immediate feedback to the developer in-context as code is written or modified.
Other tools can be more in-depth, but are slower and not as well suited to a typical development code-build-test cycle. 
They are better suited to periodic execution (overnight, for example), and can produce reports that describe the 
issues/potential issues along with suggested remediation. Commercial solutions are available (for example, 
[http://www.fortify.com/ Fortify Source Code Analysis]), as well as some popular and capable open-source packages.

A frequent (and valid) criticism of code analysis tools is that they tend to identify many false positives, which take 
effort to separate from the actual problems that the tool finds. Most tools, though, allow a simple way to configure 
families of issues to be identified or ignored (through configuration files or command-line options, for example), and 
allow individual findings to be ignored as false positives (e.g., through comments as in PMD, or annotations as in 
!FindBugs).

All of the tools listed below can be used from Ant or Maven. The sample applications have examples of integrating them 
([source:branches/sample-ant/build.xml Ant build.xml], [source:branches/sample-maven/pom.xml Maven pom.xml]). 
In addition, [//jenkins/ Jenkins] is configured to report on each.

<% node['tools']['analysis'].each do |tool| %>
 <% if ::File.directory?("#{node['tools']['base_dir']}/#{tool}-#{node['tools'][tool]['version']}") || ::File.exists?("#{node['tools']['base_dir']}/#{tool}-#{node['tools'][tool]['version']}.jar") %>

== <%= node['tools'][tool]['name_friendly'] %> ==

[<%= node['tools'][tool]['description']['link'] %> <%= node['tools'][tool]['name'] %>] <%= node['tools'][tool]['description']['long'] %>
 * [wiki:HowTo/<%= node['tools'][tool]['description']['howto_link'] %> How do I <%= node['tools'][tool]['description']['howto_text'] %>]
 <% end %>
<% end %>

<% if ::File.directory?("#{node['yasca']['home']}") %> 
== YASCA ==

The open source code analysis tool, Yasca, has been installed. It has the capabilities to scan code written in Java, C/C++, HTML, JavaScript, ASP, ColdFustion, PHP, COBOL, .NET, and other languages to search for programming issues defined within its library. This library can be added to by creating custom regular expressions and Yasca's functionality can be improved by integrating it with the additional code tools:

 * FindBugs
 * PMD
 * JLint
 * JavaScriptLint
 * PHPLint
 * CppCheck
 * ClamAV
 * RATS
 * Pixy
 
* [wiki:HowTo/UseYASCA How do I add YASCA analysis to my project?]
<% end %>


=== Installation Details ===
<% node['tools']['analysis'].each do |tool| %>
 <% if ::File.directory?("#{node['tools']['base_dir']}/#{tool}-#{node['tools'][tool]['version']}") || ::File.exists?("#{node['tools']['base_dir']}/#{tool}-#{node['tools'][tool]['version']}.jar") %>
<%= node['tools'][tool]['name_friendly'] %>, <% end %> <% end %> are all installed in `<%= node['tools']['base_dir'] %>`.

{{{
#!comment
The requisite files are also included in the 
[source:branches/sample-ant/tools/ tools directory] of the sample Ant application. Examples of use are in the 
[source:branches/sample-ant/build.xml Ant build.xml].
}}}


<% if ::File.directory?("#{node['yasca']['home']}") %> 
Yasca is installed in `<%= node['yasca']['home'] %>`.
<% end %>


<%= node['trac']['wiki']['footer'] %>